/*
 * generated by Xtext 2.19.0.M3
 */
package fr.irisa.cairn.graphviz.model.ide.contentassist.antlr;

import com.google.common.collect.ImmutableMap;
import com.google.inject.Inject;
import com.google.inject.Singleton;
import fr.irisa.cairn.graphviz.model.ide.contentassist.antlr.internal.InternalDottyParser;
import fr.irisa.cairn.graphviz.model.services.DottyGrammarAccess;
import java.util.Map;
import org.eclipse.xtext.AbstractElement;
import org.eclipse.xtext.ide.editor.contentassist.antlr.AbstractContentAssistParser;

public class DottyParser extends AbstractContentAssistParser {

	@Singleton
	public static final class NameMappings {
		
		private final Map<AbstractElement, String> mappings;
		
		@Inject
		public NameMappings(DottyGrammarAccess grammarAccess) {
			ImmutableMap.Builder<AbstractElement, String> builder = ImmutableMap.builder();
			init(builder, grammarAccess);
			this.mappings = builder.build();
		}
		
		public String getRuleName(AbstractElement element) {
			return mappings.get(element);
		}
		
		private static void init(ImmutableMap.Builder<AbstractElement, String> builder, DottyGrammarAccess grammarAccess) {
			builder.put(grammarAccess.getCompoundAccess().getAlternatives_1_0(), "rule__Compound__Alternatives_1_0");
			builder.put(grammarAccess.getNodeAccess().getAlternatives(), "rule__Node__Alternatives");
			builder.put(grammarAccess.getAttributeAccess().getAlternatives(), "rule__Attribute__Alternatives");
			builder.put(grammarAccess.getShapeAttributeAccess().getShapeAlternatives_2_0(), "rule__ShapeAttribute__ShapeAlternatives_2_0");
			builder.put(grammarAccess.getCompoundAttributeAccess().getCompoundAlternatives_2_0(), "rule__CompoundAttribute__CompoundAlternatives_2_0");
			builder.put(grammarAccess.getColorAttributeAccess().getAlternatives_0(), "rule__ColorAttribute__Alternatives_0");
			builder.put(grammarAccess.getColorAttributeAccess().getColorAlternatives_2_0(), "rule__ColorAttribute__ColorAlternatives_2_0");
			builder.put(grammarAccess.getStyleAttributeAccess().getStyleAlternatives_2_0(), "rule__StyleAttribute__StyleAlternatives_2_0");
			builder.put(grammarAccess.getRankAttributeAccess().getDirectionAlternatives_2_0(), "rule__RankAttribute__DirectionAlternatives_2_0");
			builder.put(grammarAccess.getGraphAccess().getGroup(), "rule__Graph__Group__0");
			builder.put(grammarAccess.getCompoundAccess().getGroup(), "rule__Compound__Group__0");
			builder.put(grammarAccess.getCompoundAccess().getGroup_1(), "rule__Compound__Group_1__0");
			builder.put(grammarAccess.getCompoundAccess().getGroup_1_0_0(), "rule__Compound__Group_1_0_0__0");
			builder.put(grammarAccess.getCompoundAccess().getGroup_1_0_0_1(), "rule__Compound__Group_1_0_0_1__0");
			builder.put(grammarAccess.getLeafNodeAccess().getGroup(), "rule__LeafNode__Group__0");
			builder.put(grammarAccess.getLeafNodeAccess().getGroup_1(), "rule__LeafNode__Group_1__0");
			builder.put(grammarAccess.getLeafNodeAccess().getGroup_1_2(), "rule__LeafNode__Group_1_2__0");
			builder.put(grammarAccess.getSubNodeAccess().getGroup(), "rule__SubNode__Group__0");
			builder.put(grammarAccess.getShapeAttributeAccess().getGroup(), "rule__ShapeAttribute__Group__0");
			builder.put(grammarAccess.getCompoundAttributeAccess().getGroup(), "rule__CompoundAttribute__Group__0");
			builder.put(grammarAccess.getColorAttributeAccess().getGroup(), "rule__ColorAttribute__Group__0");
			builder.put(grammarAccess.getStyleAttributeAccess().getGroup(), "rule__StyleAttribute__Group__0");
			builder.put(grammarAccess.getLabelAttributeAccess().getGroup(), "rule__LabelAttribute__Group__0");
			builder.put(grammarAccess.getRankAttributeAccess().getGroup(), "rule__RankAttribute__Group__0");
			builder.put(grammarAccess.getGraphAccess().getNameAssignment_1(), "rule__Graph__NameAssignment_1");
			builder.put(grammarAccess.getGraphAccess().getBodyAssignment_2(), "rule__Graph__BodyAssignment_2");
			builder.put(grammarAccess.getCompoundAccess().getNodesAssignment_1_0_0_0(), "rule__Compound__NodesAssignment_1_0_0_0");
			builder.put(grammarAccess.getCompoundAccess().getNodesAssignment_1_0_0_1_1(), "rule__Compound__NodesAssignment_1_0_0_1_1");
			builder.put(grammarAccess.getCompoundAccess().getAttributesAssignment_1_0_1(), "rule__Compound__AttributesAssignment_1_0_1");
			builder.put(grammarAccess.getCompoundAccess().getSubAssignment_1_0_2(), "rule__Compound__SubAssignment_1_0_2");
			builder.put(grammarAccess.getLeafNodeAccess().getNameAssignment_0(), "rule__LeafNode__NameAssignment_0");
			builder.put(grammarAccess.getLeafNodeAccess().getAttributesAssignment_1_1(), "rule__LeafNode__AttributesAssignment_1_1");
			builder.put(grammarAccess.getLeafNodeAccess().getAttributesAssignment_1_2_1(), "rule__LeafNode__AttributesAssignment_1_2_1");
			builder.put(grammarAccess.getSubNodeAccess().getNameAssignment_1(), "rule__SubNode__NameAssignment_1");
			builder.put(grammarAccess.getSubNodeAccess().getBodyAssignment_2(), "rule__SubNode__BodyAssignment_2");
			builder.put(grammarAccess.getShapeAttributeAccess().getShapeAssignment_2(), "rule__ShapeAttribute__ShapeAssignment_2");
			builder.put(grammarAccess.getCompoundAttributeAccess().getCompoundAssignment_2(), "rule__CompoundAttribute__CompoundAssignment_2");
			builder.put(grammarAccess.getColorAttributeAccess().getColorAssignment_2(), "rule__ColorAttribute__ColorAssignment_2");
			builder.put(grammarAccess.getStyleAttributeAccess().getStyleAssignment_2(), "rule__StyleAttribute__StyleAssignment_2");
			builder.put(grammarAccess.getLabelAttributeAccess().getLabelAssignment_2(), "rule__LabelAttribute__LabelAssignment_2");
			builder.put(grammarAccess.getRankAttributeAccess().getDirectionAssignment_2(), "rule__RankAttribute__DirectionAssignment_2");
		}
	}
	
	@Inject
	private NameMappings nameMappings;

	@Inject
	private DottyGrammarAccess grammarAccess;

	@Override
	protected InternalDottyParser createParser() {
		InternalDottyParser result = new InternalDottyParser(null);
		result.setGrammarAccess(grammarAccess);
		return result;
	}

	@Override
	protected String getRuleName(AbstractElement element) {
		return nameMappings.getRuleName(element);
	}

	@Override
	protected String[] getInitialHiddenTokens() {
		return new String[] { "RULE_WS", "RULE_ML_COMMENT", "RULE_SL_COMMENT" };
	}

	public DottyGrammarAccess getGrammarAccess() {
		return this.grammarAccess;
	}

	public void setGrammarAccess(DottyGrammarAccess grammarAccess) {
		this.grammarAccess = grammarAccess;
	}
	
	public NameMappings getNameMappings() {
		return nameMappings;
	}
	
	public void setNameMappings(NameMappings nameMappings) {
		this.nameMappings = nameMappings;
	}
}
